LoadAddOn('Blizzard_TimeManager')

local _G = _G

local clockFrame, clockTime = TimeManagerClockButton:GetRegions()

MiniMapWorldMapButton:Hide()
MinimapBorderTop:Hide()
MinimapNorthTag:Hide()
MinimapZoomOut:Hide()
MinimapZoomIn:Hide()
MiniMapTracking:Hide()
MinimapBorder:Hide()
GameTimeFrame:Hide()
clockFrame:Hide()
clockTime:Show()

local DoubleBinary_Minimap = CreateFrame("Frame", "Double Binary Minimap", DoubleBinary_MinimapFrame)
local DoubleBinary_MinimapText = DoubleBinary_Minimap:CreateFontString("Double Binary Minimap")
local DoubleBinary_MinimapTitle = CreateFrame("Frame", "Double Binary Minimap Title", DoubleBinary_Minimap)
local DoubleBinary_MinimapTitleText = DoubleBinary_Minimap:CreateFontString("Double Binary Minimap Title")
local DoubleBinary_MinimapClock = CreateFrame("Frame", "Double Binary Minimap Cluster", UIParent)
local DoubleBinary_MinimapClockText = DoubleBinary_MinimapClock:CreateFontString("Double Binary Minimap Cluster")
local DoubleBinary_LFD = CreateFrame("Frame", "Double Binary Minimap LFD", UIParent)
local DoubleBinary_LFDText = DoubleBinary_LFD:CreateFontString("Double Binary LFD")

DoubleBinary_BarAnchor(DoubleBinary_Minimap, DoubleBinary_MinimapText, "Double Binary Minimap", 1, 1, "TOPRIGHT", DoubleBinary_MinimapFrame, "TOPRIGHT", -30, -20, 140, 140, 0, 0,0,0.8)
DoubleBinary_BarAnchor(DoubleBinary_MinimapTitle, DoubleBinary_MinimapTitleText, "Double Binary Minimap", 1, 1, "BOTTOMRIGHT", DoubleBinary_Minimap, "TOPRIGHT", 0, 0, 140, 20, 0, 0,0.8,0.8)
DoubleBinary_BarAnchor(DoubleBinary_MinimapClock, DoubleBinary_MinimapClockText, "Double Binary Minimap Clock", 1, 1, "TOPRIGHT", DoubleBinary_Minimap, "BOTTOMRIGHT", 0, 10, 50, 20, 0, 0,0,0.8)
DoubleBinary_BarAnchor(DoubleBinary_LFD, DoubleBinary_LFDText, "Double Binary LFD", 1, 1, "BOTTOMLEFT", DoubleBinary_Minimap, "BOTTOMRIGHT", 0, 0, 30, 160, 0, 0,0,0.8)

Minimap:ClearAllPoints()
Minimap:EnableMouseWheel(1)
Minimap:SetMaskTexture("Interface\\AddOns\\DoubleBinary_Minimap\\textures\\Mask.blp")
Minimap:SetPoint("TOPLEFT", DoubleBinary_Minimap, "TOPLEFT", 0,0)
Minimap:SetScale(1)
Minimap:SetScript("OnMouseWheel", function(self, arg1) if arg1 == 1 then Minimap_ZoomIn() else Minimap_ZoomOut() end end)

MinimapZoneText:SetFont(DoubleBinary_Font, 18, "OUTLINE")
MinimapZoneTextButton:ClearAllPoints()
MinimapZoneTextButton:SetPoint("CENTER", DoubleBinary_MinimapTitle, "CENTER", 0,0)

TimeManagerClockButton:ClearAllPoints()
TimeManagerClockButton:SetPoint("TOPRIGHT", DoubleBinary_MinimapClock, "TOPRIGHT", 0,0)
clockTime:SetFont(DoubleBinary_Font, 20, "OUTLINE")
clockTime:SetTextColor(0,1,0)
if(CalendarGetNumPendingInvites() > 0) then
	clockTime:SetTextColor(1, 0, 0)
end

MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("TOP", DoubleBinary_Minimap, 0, -3)
MiniMapBattlefieldFrame:SetScale(.9)
MiniMapBattlefieldBorder:Hide()

MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", DoubleBinary_Minimap, 0, -4)
MiniMapInstanceDifficulty:SetFrameStrata("HIGH")

MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetParent(Minimap)
MiniMapMailFrame:SetPoint("RIGHT", -4, 0)
MiniMapMailFrame:SetHeight(16)
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture("Interface\\AddOns\\DoubleBinary_Minimap\\textures\\mail")

MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrame:SetPoint("TOP", DoubleBinary_LFD, "TOP", 0, 4)
MiniMapLFGFrameBorder:SetAlpha(0)
LFDSearchStatusTank1:ClearAllPoints()
LFDSearchStatusTank1:SetScale(0.5)
LFDSearchStatusTank1:SetParent(MiniMapLFGFrame)
LFDSearchStatusTank1:SetPoint("TOP", MiniMapLFGFrame, "BOTTOM", 0, 4)
LFDSearchStatusHealer1:ClearAllPoints()
LFDSearchStatusHealer1:SetParent(LFDSearchStatusTank1)
LFDSearchStatusHealer1:SetPoint("TOP", LFDSearchStatusTank1, "BOTTOM", 0, 0)
LFDSearchStatusDamage1:ClearAllPoints()
LFDSearchStatusDamage1:SetParent(LFDSearchStatusHealer1)
LFDSearchStatusDamage1:SetPoint("TOP", LFDSearchStatusHealer1, "BOTTOM", 0, 0)
LFDSearchStatusDamage2:ClearAllPoints()
LFDSearchStatusDamage2:SetParent(LFDSearchStatusDamage1)
LFDSearchStatusDamage2:SetPoint("TOP", LFDSearchStatusDamage1, "BOTTOM", 0, 0)
LFDSearchStatusDamage3:ClearAllPoints()
LFDSearchStatusDamage3:SetParent(LFDSearchStatusDamage2)
LFDSearchStatusDamage3:SetPoint("TOP", LFDSearchStatusDamage2, "BOTTOM", 0, 0)
MiniMapLFGFrameDropDown_Update()

Minimap:SetScript('OnMouseUp', function(self, button)
    if (button == 'RightButton') then
        ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, - (Minimap:GetWidth() * 0.7), -3)
    elseif (button == 'MiddleButton') then
        ToggleCalendar()
    else
        Minimap_OnClick(self)
    end
end)

DoubleBinary_MinimapFrame:RegisterEvent("MINIMAP_PING")
DoubleBinary_MinimapFrame:SetScript("OnEvent", function(_,_,unit,...)
	local ping_name = UnitName(unit)
	print("Minimap pinged by: |cffFF0000" .. ping_name .. "|r") 
end)


print(" - Minimap Module loaded.")